<?php

include_once "base_de_datos.php";

function login($correo, $password)
{
    # Primero obtener usuario...
    $posibleUsuarioRegistrado = obtenerUsuarioPorCorreo($correo);
    if ($posibleUsuarioRegistrado === false) {
        # Si no existe, salimos y regresamos false
        return false;
    }
    # Esto se ejecuta en caso de que exista
    # Comprobar contraseñas
    # Sacar el hash que tenemos en la BD
    $passwordDeBaseDeDatos = $posibleUsuarioRegistrado->password;
    $coinciden = coincidenpasswords($password, $passwordDeBaseDeDatos);
    # Si no coinciden, salimos de una vez
    if (!$coinciden) {
        return false;
    }

    # En caso de que sí hayan coincidido iniciamos sesión pasando el objeto
    iniciarSesion($posibleUsuarioRegistrado);
    # Y regresamos true ;)
    return true;
}

function usuarioExiste($correo)
{
    $base_de_datos = obtenerBaseDeDatos();
    $sentencia = $base_de_datos->prepare("SELECT correo FROM usuarios WHERE correo = ? LIMIT 1;");
    $sentencia->execute([$correo]);
    return $sentencia->rowCount() > 0;
}

function obtenerUsuarioPorCorreo($correo)
{
    $base_de_datos = obtenerBaseDeDatos();
    $sentencia = $base_de_datos->prepare("SELECT * FROM usuarios WHERE correo = ? LIMIT 1;");
    $sentencia->execute([$correo]);
    return $sentencia->fetchObject();
}

function registrarUsuario($nombre, $edad,  $correo, $telefono, $password)
{
    # NUNCA guardes contraseñas en texto plano
    $password = hashearpassword($password);
    $base_de_datos = obtenerBaseDeDatos();
    $sentencia = $base_de_datos->prepare("INSERT INTO usuarios(nombre, edad, correo, telefono, password, rolid) values(?, ?, ?, ?, ?, 1)");
    return $sentencia->execute([$nombre, $edad, $correo, $telefono, $password]);
    
}





function iniciarSesion($usuario)
{
    // Se encarga de poner los datos dentro de la sesión
    session_start();
    # Y poner los datos, no recomiendo poner la contraseña
    $_SESSION["nombre"] = $usuario->nombre;
    $_SESSION["edad"] = $usuario->edad;
    $_SESSION["correo"] = $usuario->correo;
    $_SESSION["telefono"] = $usuario->telefono;
    $_SESSION["rolid"] = $usuario->rolid;
    $_SESSION["fechamuestra"] = $usuario->fechamuestra;
}



function coincidenpasswords($password, $passwordDeBaseDeDatos)
{
    return password_verify($password, $passwordDeBaseDeDatos);
}

function hashearpassword($password)
{
    return password_hash($password, PASSWORD_BCRYPT);
}







